package com.yice.webadmin.app.controller;

import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.ImportUtil;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.dto.DatasetDetailDto;
import com.yice.webadmin.app.model.DatasetDetail;
import com.yice.webadmin.app.service.DatasetDetailService;
import com.yice.webadmin.app.vo.DatasetDetailVo;
import com.yice.webadmin.config.ApplicationConfig;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.Objects;

/**
 * 数据集详情操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "数据集详情管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/datasetDetail")
public class DatasetDetailController {

    @Autowired
    private DatasetDetailService datasetDetailService;

    @Autowired
    private ApplicationConfig appConfig;

    /**
     * 新增数据集详情数据。
     *
     * @param datasetDetailDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"datasetDetailDto.detailId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody DatasetDetailDto datasetDetailDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetDetailDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetDetail datasetDetail = MyModelUtil.copyTo(datasetDetailDto, DatasetDetail.class);
        datasetDetail = datasetDetailService.saveNew(datasetDetail);
        return ResponseResult.success(datasetDetail.getDetailId());
    }

    /**
     * 更新数据集详情数据。
     *
     * @param datasetDetailDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody DatasetDetailDto datasetDetailDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetDetailDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetDetail datasetDetail = MyModelUtil.copyTo(datasetDetailDto, DatasetDetail.class);
        DatasetDetail originalDatasetDetail = datasetDetailService.getById(datasetDetail.getDetailId());
        if (originalDatasetDetail == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetDetailService.update(datasetDetail, originalDatasetDetail)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除数据集详情数据。
     *
     * @param detailId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long detailId) {
        if (MyCommonUtil.existBlankArgument(detailId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(detailId);
    }

    /**
     * 列出符合过滤条件的数据集详情列表。
     *
     * @param datasetDetailDtoFilter 过滤对象。
     * @param orderParam             排序参数。
     * @param pageParam              分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<DatasetDetailVo>> list(
            @MyRequestBody DatasetDetailDto datasetDetailDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetDetail datasetDetailFilter = MyModelUtil.copyTo(datasetDetailDtoFilter, DatasetDetail.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, DatasetDetail.class);
        List<DatasetDetail> datasetDetailList =
                datasetDetailService.getDatasetDetailListWithRelation(datasetDetailFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(datasetDetailList, DatasetDetail.INSTANCE));
    }

    /**
     * 查看指定数据集详情对象详情。
     *
     * @param detailId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<DatasetDetailVo> view(@RequestParam Long detailId) {
        DatasetDetail datasetDetail = datasetDetailService.getByIdWithRelation(detailId, MyRelationParam.full());
        if (datasetDetail == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        DatasetDetailVo datasetDetailVo = DatasetDetail.INSTANCE.fromModel(datasetDetail);
        return ResponseResult.success(datasetDetailVo);
    }

    private ResponseResult<Void> doDelete(Long detailId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        DatasetDetail originalDatasetDetail = datasetDetailService.getById(detailId);
        if (originalDatasetDetail == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetDetailService.remove(detailId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }

    /**
     * 导入主表数据列表。
     *
     * @param importFile 上传的文件，目前仅仅支持xlsx和xls两种格式。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.IMPORT)
    @PostMapping("/import")
    public ResponseResult<Void> importBatch(
            @RequestParam Long datasetId,
            @RequestParam Long versionId,
            @RequestParam Boolean skipHeader,
            @RequestParam("importFile") MultipartFile importFile) throws IOException {
        String errorMessage;
        if (Objects.isNull(importFile) || importFile.isEmpty()) {
            errorMessage = "数据验证失败，导入文件不能为空！";
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST, errorMessage);
        }
        ImportUtil.saveImportFile(appConfig.getUploadFileBaseDir(), null, importFile);
        // 这里可以指定需要忽略导入的字段集合。如创建时间、创建人、更新时间、更新人、主键Id和逻辑删除，
        // 以及一些存在缺省值且无需导入的字段。其中主键字段和逻辑删除字段不需要在这里设置，批量插入逻辑会自动处理的。
        /*Set<String> ignoreFieldSet = new HashSet<>();
        ignoreFieldSet.add("createUserId");
        ignoreFieldSet.add("createTime");
        ignoreFieldSet.add("updateUserId");
        ignoreFieldSet.add("updateTime");
        List<ImportUtil.ImportHeaderInfo> headerInfoList = ImportUtil.makeHeaderInfoList(DatasetDetail.class, ignoreFieldSet);
        // TODO: 下面是导入时需要注意的地方，如果我们缺省生成的代码，与实际情况存在差异，请手动修改。
        // 1. 头信息数据字段，我们只是根据当前的主表实体对象生成了缺省数组，开发者可根据实际情况，对headerInfoList进行修改。
        ImportUtil.ImportHeaderInfo[] headerInfos = headerInfoList.toArray(new ImportUtil.ImportHeaderInfo[]{});
        // 2. 这里需要根据实际情况决定，导入文件中第一行是否为中文头信息，如果是可以跳过。这里我们默认为true。
        // 这里根据自己的实际需求，为doImport的最后一个参数，传递需要进行字典转换的字段集合。
        // 注意，集合中包含需要翻译的Java字段名，如: gradeId。
        Set<String> translatedDictFieldSet = new HashSet<>();
        List<DatasetDetail> dataList =
                ImportUtil.doImport(headerInfos, skipHeader, filename, DatasetDetail.class, translatedDictFieldSet);
        datasetDetailService.saveNewBatch(dataList, -1);*/
        return ResponseResult.success();
    }
}
